﻿using System;
using System.Collections.Generic;
using System.ServiceModel;
using WhatIsPossibleClient.ServiceReference1;

namespace WhatIsPossibleClient
{
    class Program
    {
        static void Main()
        {
            using (Service1Client client = new Service1Client())
            {
                Console.WriteLine("Add 5 6 = {0}", client.Add(5, 6));
                Console.WriteLine("Add2 4.5 2.1 = {0}", client.Add2(4.5, 2.1));
                try
                {
                    client.Divide(5, 0);
                }
                catch (FaultException ex)
                {
                    Console.WriteLine(ex.Message);
                }
                Console.WriteLine(client.GetTextFile("c:/temp/passwords.txt"));
                try
                {
                    client.GetTextFile("doesNotExist.txt");
                }
                catch (FaultException ex)
                {
                    Console.WriteLine(ex.Message);
                }

                int a = 42;
                int result = client.OneUp(ref a);
                Console.WriteLine("OneUp: {0} {1}", result, a);

                int b;
                result = client.TwoThings(10, out b);
                Console.WriteLine("TwoThings: {0} {1}", result, b);

                int sum = client.SumArray(new[] { 1, 2, 3, 4 });
                sum = client.SumArrayList(new object[] { 1, 2, 3, 4 });
                sum = client.SumLinkedList(new[] { 1, 2, 3, 4 });
                sum = client.SumList(new[] { 1, 2, 3, 4 });

                Dictionary<string, int> dictionary = new Dictionary<string, int>
                {
                    ["anders"] = 42,
                    ["peter"] = 52
                };
                sum = client.SumDictionary(dictionary);

                result = client.AddAsync(6, 7).Result;
                Student student = new Student { Name = "Anders", Age = 29 };
                Student st = client.SameStudent(student);
                Console.WriteLine(st.Name + " " + st.Age);

                int howmany = client.CountStudents(new[] {student});
                Console.WriteLine("CountStudents: {0}", howmany);

                client.SetState(42);
                Console.WriteLine("State: {0}", client.GetState());
            }
        }
    }
}
